#pragma once

#include "ofMain.h"
#include <XnCppWrapper.h>
#include <XnTypes.h>
#include <XnLog.h>

class testApp : public ofBaseApp{

	public:

		void setup();
		void update();
		void draw();
		void exit();
	
		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void windowResized(int w, int h);
		void dragEvent(ofDragInfo dragInfo);
		void gotMessage(ofMessage msg);	
	
	xn::ScriptNode scriptNode;
	xn::Context context;
	xn::DepthGenerator depthGenerator;
	xn::ImageGenerator imageGenerator;
	xn::Device device;
	
	struct DeviceParameter
	{
		int numValues;
		unsigned int values[20];
		string name[20];
	};
	
	struct NodeCodec
	{
		int numValues;
		XnCodecID values[20];
		string name[20];
	};
	
	struct DeviceStringProperty
	{
		int numValues;
		string name[20];
	};
	
	DeviceStringProperty primaryStream;
	DeviceParameter registration;
	DeviceParameter resolution;
	
	bool isDepthOn;
	bool isImageOn;
	bool isDepthRawOnOption;
	string configXMLPath;
	
	void createGenerators();
	void start();
	void initConstants();
	void allocateDepthBuffers();
	
	int cameraWidth;
	int cameraHeight;
	
	// depth
	xn::DepthMetaData depthMetaData;
	ofTexture depthTexture;
	ofPixels currentDepthPixels;
	float	deviceMaxDepth;
	
	
	bool bNewPixels;
	bool isFrameNew;
	void readFrame();
	void generateDepthPixels();
};

